#ifndef	lint
static char *copyright = "\n\
\n\
Copyright (c) 1993 by Bennet Yee.\n\
\n\
This material was developed by the author.  Permission to copy this\n\
software, to redistribute it, and to use it for any purpose is hereby\n\
granted, subject to the following five restrictions.\n\
\n\
1. Any copy made of this software must include this copyright notice in\n\
full.\n\
\n\
2. All materials containing this software or derivatives thereof must\n\
provide this software in source form or provide a means of obtaining\n\
this software in source form; no fees may be charged for this software\n\
except those for covering media costs and handling.\n\
\n\
3. All materials developed as a consequence of the use of this software\n\
shall duly acknowledge such use, in accordance with the usual standards\n\
of acknowledging credit in academic research.\n\
\n\
4. The author makes no warranty or representation that the operation\n\
of this software will be error-free, and the author is under no\n\
obligation to provide any services, by way of maintenance, update, or\n\
otherwise.\n\
\n\
5. In conjunction with products arising from the use of this material,\n\
there shall be no use of the names of the author, of Carnegie-Mellon\n\
University, nor of any adaptation thereof in any advertising,\n\
promotional, or sales literature without prior written consent from the\n\
author and Carnegie-Mellon University in each case.\n\
\n\
If you have questions, you can contact the author at bsy@cs.cmu.edu\n\
\n\
Users of this software is requested to make their best efforts (a) to\n\
return to the author any improvements or extensions that they make, so\n\
that these may be included in future releases; (b) to document clearly\n\
any improvements or extensions made to this software; and (c) to inform\n\
the author of noteworthy uses of this software.  Any improvements or\n\
extensions to this software may be placed under different copyright\n\
restrictions by the author of those improvements or extensions.  That\n\
those improvements or extensions be placed under the same copyright as\n\
this software is encouraged.\n\
";
#endif	/* lint */
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/signal.h>

#define	DEBUG		0
#define	TIMEOUT		10

int	pregnant = 1;
int	ip[2],op[2];

extern int	exit();

main(ac,av)
int	ac;
char	**av;
{
	char		buf[4096];
	int		len;
	fd_set		set;
	union {
		struct sockaddr	from;
		char		b[4096];
	}		u;
	int		fromlen;

	if (ac <= 1) {
		fprintf(stderr,"program argument needed\n");
		exit(1);
	}
	if (pipe(ip) == -1) {
		perror("updsrv: in pipe");
		exit(1);
	}
	if (pipe(op) == -1) {
		perror("updsrv: out pipe");
		exit(1);
	}
	signal(SIGALRM,(void (*)(int)) exit);
	alarm(TIMEOUT);
	for (;;) {
		FD_ZERO(&set);
		FD_SET(0,&set);
		FD_SET(op[0],&set);
		if (select(op[0]+1,&set,(fd_set *) 0,(fd_set *) 0,(struct timeval *) 0) == -1) {
			perror("updsrv: select");
			exit(1);
		}
		alarm(0);
		if (FD_ISSET(op[0],&set)) {
#if	DEBUG
			fprintf(stderr,"has data from server proc\n");
#endif	DEBUG
			if ((len = read(op[0],buf,sizeof buf)) <= 0) {
				if (len != 0)
					perror("updsrv: out pipe read");
				exit(0);
			}
#if	DEBUG
			fprintf(stderr,"got data from server, sending to client\n");
#endif	DEBUG
			if (sendto(1,buf,len,0,&u.from,fromlen) == -1) {
				perror("updsrv: result send");
				exit(1);
			}
#if	DEBUG
			fprintf(stderr,"sent to client\n");
#endif	DEBUG
		}
		if (FD_ISSET(0,&set)) {
#if	DEBUG
			fprintf(stderr,"has data from client\n");
#endif	DEBUG
			fromlen = sizeof u;
			if ((len = recvfrom(0,buf,sizeof buf,0,&u.from,&fromlen)) <= 0) {
				perror("updsrv: input read");
				exit(0);
			}
#if	DEBUG
			fprintf(stderr,"Got data from socket\n");
#endif	DEBUG
			if (pregnant) give_birth(av);
			/*
			 * should be non-blocking, queuing excess
			 * for selected write.
			 */
			if (write(ip[1],buf,len) != len) {
				perror("updsrv: in pipe write");
				exit(1);
			}
#if	DEBUG
			fprintf(stderr,"Sent to server proc\n");
#endif	DEBUG
		}
	}
}

give_birth(av)
char	**av;
{
#if	DEBUG
	fprintf(stderr,"Forking child\n");
#endif	DEBUG
	switch (fork()) {
	case -1:
		perror("udpsrv: no fork!");
		exit(1);
	case 0:
		(void) close(ip[1]); (void) dup2(ip[0],0); (void) close(ip[0]);
		(void) close(op[0]); (void) dup2(op[1],1); (void) close(op[1]);
		execv(av[1],av+1);
		fprintf(stderr,"Can not exec ``%s''!\n",av[1]);
		_exit(1);
	default:
		(void) close(ip[0]); (void) close(op[1]);
		pregnant = 0;
		return;
	}
}
