#ifndef	lint
static char *copyright = "\n\
\n\
Copyright (c) 1994 by Bennet Yee.\n\
\n\
This material was developed by the author.  Permission to copy this\n\
software, to redistribute it, and to use it for any purpose is hereby\n\
granted, subject to the following five restrictions.\n\
\n\
1. Any copy made of this software must include this copyright notice in\n\
full.\n\
\n\
2. All materials containing this software or derivatives thereof must\n\
provide this software in source form or provide a means of obtaining\n\
this software in source form; no fees may be charged for this software\n\
except those for covering media costs and handling.\n\
\n\
3. All materials developed as a consequence of the use of this software\n\
shall duly acknowledge such use, in accordance with the usual standards\n\
of acknowledging credit in academic research.\n\
\n\
4. The author makes no warranty or representation that the operation\n\
of this software will be error-free, and the author is under no\n\
obligation to provide any services, by way of maintenance, update, or\n\
otherwise.\n\
\n\
5. In conjunction with products arising from the use of this material,\n\
there shall be no use of the names of the author, of Carnegie-Mellon\n\
University, nor of any adaptation thereof in any advertising,\n\
promotional, or sales literature without prior written consent from the\n\
author and Carnegie-Mellon University in each case.\n\
\n\
If you have questions, you can contact the author at bsy@cs.cmu.edu\n\
\n\
Users of this software is requested to make their best efforts (a) to\n\
return to the author any improvements or extensions that they make, so\n\
that these may be included in future releases; (b) to document clearly\n\
any improvements or extensions made to this software; and (c) to inform\n\
the author of noteworthy uses of this software.  Any improvements or\n\
extensions to this software may be placed under different copyright\n\
restrictions by the author of those improvements or extensions.  That\n\
those improvements or extensions be placed under the same copyright as\n\
this software is encouraged.\n\
";
#endif
/* lint */

/*
 * Privileged port for non-privileged server code.
 *
 * This program either runs setuid with restricted access (via filesystem)
 * and restores before exec'ing the server, or root runs the non-privileged
 * server as
 *	priv_port -p 80 -d 3 -- ru nobody httpd-no-priv (CMUism)
 * or
 *	priv_port -p 80 -d 3 -- su -f nobody -c exec httpd-no-priv
 *
 * 94/11/11, bsy.
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#define	PORT	80
#define	DESC	3

usage()
{
	fprintf(stderr,"Usage:  priv_port [-v] [-p port] [-d desc-num] -- cmd [opts]\n");
}

main(ac,av)
int	ac;
char	**av;
{
	int			s, set, reuse = 1, ruid, ch;
	struct sockaddr_in	name;
	u_short			port = PORT;
	int			desc = DESC;

	extern int		getopt(), optind;
	extern char		*optarg;

	while ((ch = getopt(ac,av,"d:p:rR")) != EOF) switch (ch) {
	case 'd':	desc = atoi(optarg);	break;
	case 'p':	port = atoi(optarg);	break;
	case 'r':	reuse = 1;		break;
	case 'R':	reuse = 0;		break;
	default:	usage(); exit(1);
	}

	if (optind >= ac) {
		usage(); exit(1);
	}

	if ((s = socket(PF_INET,SOCK_STREAM,0)) == -1) {
		perror("socket");
		exit(1);
	}

	if (reuse) {
		set = 1;
		if (setsockopt(s,SOL_SOCKET,SO_REUSEADDR,(const char *) &set, sizeof(set)) == -1) {
			perror("setsockoopt");
			exit(1);
		}
	}

	memset((char *)&name,0,sizeof(name));
	name.sin_family = AF_INET;
	name.sin_port = htons(port);

	if (bind(s,(struct sockaddr *) &name,sizeof(name)) == -1) {
		perror("bind");
		exit(1);
	}
	if (s != desc) {
		(void) dup2(s,desc);
		(void) close(s);
	}
	ruid = getuid();
#if	defined(_POSIX_VERSION)
	(void) setuid(ruid);
#elif	__hppa
	(void) setresuid(ruid,ruid,ruid);
#else
	(void) setreuid(ruid,ruid);
#endif
	execvp(av[optind],av+optind);
	perror("exec");
	exit(1);
	/* NOTREACHED */
}
